//+-------------------------------------------------------------------+
//|                                MF_Pivot AXEL 0-2254.mq4           |
//|                                Copyright  YuraZ-VAF-Zhunko-Nestor|
//|                                MF YURAZ     yzh@mail.ru           |
//|                                MF VAF  vazh-af@inbox.ru           |
//|                                MF ZHUNKO zhunko@mail.ru           |
//|                                MF NESTOR a_nesterchuk@mail.ru     |
//+-------------------------------------------------------------------+
//|      .                    |
//|  .                                              |
//|    5   DJ  Axel Rudolph !          |
//|    M1.                                                |
//|                          !                               |
//|        - PIVOT   . |
//+-------------------------------------------------------------------+
//|                      .                        |
//| 1.   MF_Pivot AXEL 0-101  06.09.2006 .         |
//| 1.1.       XY   |
//| 1.2.   .                               |
//| 1.3.   .                               |
//| 2.   MF_Pivot AXEL 0-102  08.09.2006 .         |
//| 2.1.      .     |
//| 3.   MF_Pivot AXEL 0-103  09.09.2006 .         |
//| 3.1.     .            |
//| 3.2.   .                         |
//| 3.3.    .                  |
//| 3.4.     4  GMT.           |
//| 4.   MF_Pivot AXEL 0-113  14.09.2006 .         |
//| 4.1.    .               |
//| 5.   MF_Pivot AXEL 0-114  17.09.2006 .         |
//| 5.1.           |
//|       .                                       |
//| 5.2.  ,  JPY,    |
//|          .         |
//|       - .                                      |
//| 6.   MF_Pivot AXEL 0-214  18.09.2006 .         |
//| 6.1                 |
//|      .                                        |
//| 7.   MF_Pivot AXEL 0-224  19.09.2006 .         |
//| 7.1.     .                |
//| 8.   MF_Pivot AXEL 0-225  24.09.2006 .         |
//| 8.1.      .           |
//| 8.2.      "99999999,0000"      |
//|      "0,0000".                                           |
//| 9.   MF_Pivot AXEL 0-2254  06.10.2006 .        |
//| 9.1.         |
//|       .                                    |
//| 9.2.  .                              |
//| 9.3.      .    |    
//+-------------------------------------------------------------------+
#property copyright "Copyright  2006 YuraZ-VAF-Zhunko-Nestor"
#property link      "yzh@mail.ru ; vazh-af@inbox.ru ; zhunko@mail.ru ; a_nesterchuk@mail.ru"


#property indicator_chart_window 
#property indicator_buffers 1
//  .
#property indicator_color1 Lavender
//  .
#property indicator_style1 STYLE_DASH
//   .
#property indicator_width1 1
//-------------------------------------------------------------------------------------------------------------------------------------
extern int     = 7;                       //   .
extern double _ = 2;                    //     4  GMT.
extern bool   Time_Summer = false;              // true -   / false -  .
//----   -------------------------------------------------------------------------------------------------------------
extern double Asia___   = 12 ; //      .
extern double Europe___ =  9 ; //      .
extern double USA___    =  6 ; //      .
//----         --------------------------------------------------------------------
extern string Start_ASIA          = "00:15" ;  //        GMT.
                                               //     "PIVOT DJ ASIA" (  ,  ).
extern string Start_EUROPE_Winter = "06:15" ;  //        GMT.
                                               //     "PIVOT DJ EUROPE" (  ,  ).
extern string Start_USA_Winter    = "12:00" ;  //        GMT.
                                               //     "PIVOT DJ USA" (  ,  ).
//---- -----------------------------------------------------------------------------------------------------------------------
extern int             =   0   ;    //   : 0 =  , 1 =  , 2 =  , 3 =  .
extern int    XD           = 250   ;    //     X.
extern int    YD           =   0   ;    //     Y.
extern bool   TEXT_Visible = true  ;    // true -  ; false -   .
extern color  TextColor    = Lavender ;    //  .
//================================================================================================================================================
double nClose   = 0 ;
double nPivot   = 0 ; 
double nMaxHigh = 0 ; 
double nMinLow  = 0 ;
//---------------------------------------------------------------
double    PBuffer[];
//---------------------------------------------------------------
static string ss1 = "Asia DJ Pivot"    ;
static string ss2 = "Europe DJ Pivot"  ;
static string ss3 = "Usa DJ Pivot"     ;
static string ss4 = "Downloads"        ;
//===============================================================
int init() 
 { 
  if ( TEXT_Visible == true )
   {
    ObjectCreate(ss4, OBJ_LABEL, 0, 0, 0);   
    ObjectSet(ss4, OBJPROP_XDISTANCE, XD);
    ObjectSet(ss4, OBJPROP_YDISTANCE, YD);
    ObjectSet(ss4, OBJPROP_CORNER, );

    ObjectCreate(ss1, OBJ_LABEL, 0, 0, 0);   
    ObjectSet(ss1, OBJPROP_XDISTANCE, XD);
    ObjectSet(ss1, OBJPROP_YDISTANCE, 10+YD);
    ObjectSet(ss1, OBJPROP_CORNER, );

    ObjectCreate(ss2, OBJ_LABEL, 0, 0, 0);   
    ObjectSet(ss2, OBJPROP_XDISTANCE, XD);
    ObjectSet(ss2, OBJPROP_YDISTANCE, 20+YD);
    ObjectSet(ss2, OBJPROP_CORNER, );

    ObjectCreate(ss3, OBJ_LABEL, 0, 0, 0);   
    ObjectSet(ss3, OBJPROP_XDISTANCE, XD);
    ObjectSet(ss3, OBJPROP_YDISTANCE, 30+YD);
    ObjectSet(ss3, OBJPROP_CORNER, );
   }
    SetIndexStyle(0,DRAW_LINE);
    SetIndexBuffer(0,PBuffer);
  return(0); 
 }
//===============================================================
int deinit() 
{ 
if ( TEXT_Visible == true )
 {
  ObjectDelete(ss4);
  ObjectDelete(ss1);
  ObjectDelete(ss2);
  ObjectDelete(ss3);
 }
return(0); 
} 
//===============================================================
 void funPivot(int pDay, int pMonth, int pYear,  double PeriodHour, double hourMT4, double minuteMT4)
  { 
   datetime dTimeMT4end;
   datetime dTimeMT4begin;
   
   string sTimeMT4 = StringConcatenate(DoubleToStr( pYear, 0),".",DoubleToStr( pMonth , 0),".",DoubleToStr( pDay , 0)," ",
                     DoubleToStr( hourMT4, 0),":",DoubleToStr( minuteMT4, 0) ) ; 
                    
   dTimeMT4end = StrToTime(sTimeMT4); 
   dTimeMT4begin = dTimeMT4end - PeriodHour*3600+60  ;  
   
   if (TimeDayOfWeek (dTimeMT4begin) ==0)
   dTimeMT4begin = dTimeMT4begin - 172800;
   
   int      shiftend=iBarShift(NULL,PERIOD_M1,dTimeMT4end);
   int      shiftbegin=iBarShift(NULL,PERIOD_M1,dTimeMT4begin);
      
   nMinLow =iLow(NULL,PERIOD_M1,Lowest ( NULL, PERIOD_M1, MODE_LOW, shiftbegin-shiftend, shiftend));
   nMaxHigh= iHigh(NULL,PERIOD_M1,Highest( NULL, PERIOD_M1, MODE_HIGH, shiftbegin-shiftend, shiftend)); 
   nClose=iClose(NULL,PERIOD_M1,shiftend);
   nPivot = (nMaxHigh+nMinLow+nClose)/3;
   
   return; 
  } 
//================================================================
int start() 
 {
  int mDay;
  int mMonth ;
  int mYear  ;
  string mYearMonthDay;
//----------------------------------------------------------------
  static double PeriodHour_ ; // = Asia___;
  static double hourMT4_    ; // = Asia___MT4_; 
  static double minuteMT4_  ; // = Asia___MT4_; 

  static double nPivotEurope; // = nPivot; 
  static double nMaxHighE   ; // = nMaxHigh; 
  static double nMinLowE    ; // = nMinLow; 
  static double nCloseE     ; // = nClose; 

  static double nPivotUSA   ; // = nPivot; 
  static double nMaxHighU   ; // = nMaxHigh; 
  static double nMinLowU    ; // = nMinLow; 
  static double nCloseU     ; // = nClose; 

  static double nPivotASIA  ; // = nPivot; 
  static double nMaxHighA   ; // = nMaxHigh; 
  static double nMinLowA    ; // = nMinLow; 
  static double nCloseA     ; // = nClose; 
//-----------------------------------------------------------------
  datetime  mDatBegin;
  if (Bars != IndicatorCounted())
   {
    if ( == 0 )
     {
      deinit();
      return(0);
     }
  else
     {
      mDatBegin = StrToTime(StringConcatenate(TimeToStr(CurTime(),TIME_DATE)," 00:00")) - ((-1) * 86400);
     }
//==================================================================
  for ( int i =0; mDatBegin < CurTime();  mDatBegin += 86400 )
   {
    mYear  = TimeYear( mDatBegin);
    mMonth = TimeMonth( mDatBegin);
    mDay   = TimeDay( mDatBegin);
    mYearMonthDay = StringConcatenate(DoubleToStr (mYear,0) , "." , DoubleToStr (mMonth, 0) , "." , DoubleToStr (mDay , 0));
//----------------------------------------------------------------------------------------------------------------------------------------------------------------
    Start_ASIA=StringTrimRight(StringTrimLeft(Start_ASIA));
    Start_EUROPE_Winter=StringTrimRight(StringTrimLeft(Start_EUROPE_Winter));
    Start_USA_Winter=StringTrimRight(StringTrimLeft(Start_USA_Winter));
    
    if (Time_Summer==true) int TWS =1;
    else TWS=0;
    
    int  Asia_end_MT4_hour           = StrToDouble(StringSubstr(Start_ASIA, 0, 2)) + _;
    int  Asia_end_MT4_min            = StrToDouble(StringSubstr(Start_ASIA, 3, 2)) ;
                                    
    int  Europe_end_MT4_hour_pivot   = StrToDouble (StringSubstr(Start_EUROPE_Winter, 0, 2)) + _;
    int  Europe_end_MT4_hour_session = StrToDouble (StringSubstr(Start_EUROPE_Winter, 0, 2)) + _ - TWS;
    int  Europe_end_MT4_min          = StrToDouble (StringSubstr(Start_EUROPE_Winter, 3, 2)) ;
                                    
    int  USA_end_MT4_hour_pivot      = StrToDouble (StringSubstr(Start_USA_Winter, 0, 2)) + _ - TWS;
    int  USA_end_MT4_hour_session    = StrToDouble (StringSubstr(Start_USA_Winter, 0, 2)) + _ - TWS;
    int  USA_end_MT4_min             = StrToDouble (StringSubstr(Start_USA_Winter, 3, 2)) ;
//----------------------------------------------------------------------------------------------------------------------------------------------------------------*/
    PeriodHour_  = Asia___;
    hourMT4_     = Asia_end_MT4_hour;
    minuteMT4_   = Asia_end_MT4_min;
    funPivot( mDay, mMonth ,mYear ,PeriodHour_, hourMT4_, minuteMT4_);
    nPivotASIA   = nPivot;
    nMaxHighA    = nMaxHigh;
    nMinLowA     = nMinLow;
    nCloseA      = nClose;
//----------------------------------------------
    PeriodHour_  = Europe___;
    hourMT4_     = Europe_end_MT4_hour_pivot;
    minuteMT4_   = Europe_end_MT4_min;
    funPivot(mDay, mMonth,mYear,PeriodHour_, hourMT4_, minuteMT4_);
    nPivotEurope = nPivot;
    nMaxHighE    = nMaxHigh;
    nMinLowE     = nMinLow;
    nCloseE      = nClose;
//----------------------------------------------
    PeriodHour_  = USA___;
    hourMT4_     = USA_end_MT4_hour_pivot;
    minuteMT4_   = USA_end_MT4_min;
    funPivot(mDay, mMonth,mYear,PeriodHour_, hourMT4_, minuteMT4_);
    nPivotUSA    = nPivot;
    nMaxHighU    = nMaxHigh;
    nMinLowU     = nMinLow;
    nCloseU      = nClose;
//----------------------------------------------
    string DC_ASIA   = StringConcatenate(mYearMonthDay , " " , Asia_end_MT4_hour, ":00");   
    string DC_EUROPE = StringConcatenate(mYearMonthDay , " " , Europe_end_MT4_hour_session, ":00");   
    string DC_USA    = StringConcatenate(mYearMonthDay , " " , USA_end_MT4_hour_session, ":00");   
   
    int pPivotBARA = iBarShift (NULL,0,StrToTime (DC_ASIA)); 
    int pPivotBARE = iBarShift (NULL,0,StrToTime (DC_EUROPE));  
    int pPivotBARU = iBarShift (NULL,0,StrToTime (DC_USA));

      int j;

      if ( nPivotASIA !=0 )
         {
          for (j =0  ; j < pPivotBARA; j++)
            PBuffer[j] = nPivotASIA ;
         }  
      if ( nPivotEurope !=0)
         {
          for (j = 0 ; j < pPivotBARE; j++)
            PBuffer[j] = nPivotEurope ;
         }

      if (nPivotUSA !=0 )
         {
          for (j = 0 ; j < pPivotBARU; j++)
            PBuffer[j] = nPivotUSA ;
         }
   }

   if (TEXT_Visible == true )
    {
     string sPivotASIA    =  StringConcatenate("PivotAsia     =",DoubleToStr(nPivotASIA  ,Digits)," High="+DoubleToStr(nMaxHighA,Digits)," Low=",DoubleToStr(nMinLowA,Digits)," Close=",DoubleToStr(nCloseA,Digits)) ; 
     string sPivotEUROPE  =  StringConcatenate("PivotEurope="   ,DoubleToStr(nPivotEurope,Digits)," High="+DoubleToStr(nMaxHighE,Digits)," Low=",DoubleToStr(nMinLowE,Digits)," Close=",DoubleToStr(nCloseE,Digits)) ;
     string sPivotUSA     =  StringConcatenate("PivotUSA    ="  ,DoubleToStr(nPivotUSA   ,Digits)," High="+DoubleToStr(nMaxHighU,Digits)," Low=",DoubleToStr(nMinLowU,Digits)," Close="+DoubleToStr(nCloseU,Digits)) ; 

     ObjectSetText(ss1, sPivotASIA   , 8, "Tahoma", TextColor); 
     ObjectSetText(ss2, sPivotEUROPE , 8, "Tahoma", TextColor); 
     ObjectSetText(ss3, sPivotUSA    , 8, "Tahoma", TextColor); 
     ObjectSetText(ss4, "Download from www.usd.ucoz.ru", 8, "Tahoma", White); 

    }
 }
return(0);
}
//+------------------------------------------------------------------+